package in.sisoft.externalstorage;

import android.content.Intent;
import android.graphics.Bitmap;
import android.media.MediaScannerConnection;
import android.net.Uri;
import android.os.Environment;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.provider.MediaStore;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import static android.R.attr.bitmap;

public class MainActivity extends AppCompatActivity implements View.OnClickListener {
    // TextView canWrite, canread;

    String state;
    boolean canw, canr;
    private static final String TAG = "MainActivity";

    File path = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_PICTURES);

    File mFile = null;
    EditText saveFile;
    Button confirm, save, btnClick;
    Bitmap bmap1;
    ImageView iv;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        //   canWrite = (TextView) findViewById(R.id.tvCanWrite);
        //  canread = (TextView) findViewById(R.id.tvCanRead);
        confirm = (Button) findViewById(R.id.bConfirm);
        save = (Button) findViewById(R.id.bSave);
        saveFile = (EditText) findViewById(R.id.etSaveAs);
        btnClick = (Button) findViewById(R.id.btnClickImage);
        iv = (ImageView) findViewById(R.id.iv);

        btnClick.setOnClickListener(this);
        confirm.setOnClickListener(this);
        save.setOnClickListener(this);


        checkState();


    }

    private void checkState() {

        state = Environment.getExternalStorageState();
        if (state.equals(Environment.MEDIA_MOUNTED)) {
            canw = canr = true;
        } else if (state.equals(Environment.MEDIA_MOUNTED_READ_ONLY)) {
            canw = false;
            canr = true;
        } else {
            canr = canw = false;
        }
    }

    @Override
    public void onClick(View view) {
        switch (view.getId()) {
            case R.id.bSave:
                String f = saveFile.getText().toString();
                mFile = new File(path, f);
                checkState();

                path.mkdirs();

                if (canw == canr == true) {
                   // InputStream is = getResources().openRawResource(R.raw.no);

                    ByteArrayOutputStream bos = new ByteArrayOutputStream();

                    bmap1.compress(Bitmap.CompressFormat.PNG, 0 , bos);
                    byte[] bitmapdata = bos.toByteArray();
                    ByteArrayInputStream bs = new ByteArrayInputStream(bitmapdata);

                    try {
                        OutputStream os = new FileOutputStream(mFile);
                        byte[] data = new byte[bs.available()];
                        bs.read(data);
                        os.write(data);
                        bs.close();
                        os.close();

                        Toast.makeText(this, "file has been saved", Toast.LENGTH_SHORT).show();


                        //update files for the user to use...


                        MediaScannerConnection.scanFile(MainActivity.this,
                                new String[]{mFile.toString()}, null,
                                new MediaScannerConnection.OnScanCompletedListener() {

                                    @Override
                                    public void onScanCompleted(String s, Uri uri) {

                                        MainActivity.this.runOnUiThread(new Runnable() {
                                            public void run() {
                                                Toast.makeText(MainActivity.this,
                                                        "your photo has been saved in gallery",
                                                        Toast.LENGTH_SHORT).show();
                                            }
                                        });


                                    }
                                });
                    } catch (FileNotFoundException e) {
                        e.printStackTrace();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
                break;
            case R.id.bConfirm:
                save.setVisibility(View.VISIBLE);
                break;

            case R.id.btnClickImage:
                Intent cam = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
                startActivityForResult(cam, 1);
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);

        if (resultCode == RESULT_OK && requestCode == 1) {
            Bundle extras = data.getExtras();
            bmap1 = (Bitmap) extras.get("data");
            iv.setImageBitmap(bmap1);
        }
    }
}
